unit CameraJens;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,
  ComCtrls, Buttons, StdCtrls, CamerAH, Grids;

type
  TForm1 = class(TForm)
    //pnl1: TJvPanel;
    trckbr1: TTrackBar;
    btn1: TSpeedButton;
    btn2: TSpeedButton;
    btn3: TSpeedButton;
    btn4: TSpeedButton;
    btn5: TSpeedButton;
    btn6: TSpeedButton;
    btn7: TSpeedButton;
    btn8: TSpeedButton;
    btn9: TSpeedButton;
    btn10: TSpeedButton;
    btn11: TButton;
    btn12: TSpeedButton;
    tmr1: TTimer;
    lbl1: TLabel;
    rb1: TRadioButton;
    rb2: TRadioButton;
    strngrd1: TStringGrid;
    chk1: TCheckBox;
    rgView: TRadioGroup;
    chkInvers: TCheckBox;
    trckbr2: TTrackBar;
    lbl2: TLabel;
    btn13: TButton;
    chk2: TCheckBox;
    btn14: TButton;
    edt1: TEdit;
    lbl3: TLabel;
    chk3: TCheckBox;
    trckbr3: TTrackBar;
    lbl4: TLabel;
    btn15: TSpeedButton;
    trckbr4: TTrackBar;
    lbl5: TLabel;
    lbl6: TLabel;
    btn16: TSpeedButton;
    trckbr5: TTrackBar;
    lbl7: TLabel;
    pnl1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure pnl1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure pnl1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure pnl1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure trckbr1Change(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure btn2Click(Sender: TObject);
    procedure btn3Click(Sender: TObject);
    procedure btn4Click(Sender: TObject);
    procedure btn5Click(Sender: TObject);
    procedure btn6Click(Sender: TObject);
    procedure btn7Click(Sender: TObject);
    procedure btn8Click(Sender: TObject);
    procedure btn9Click(Sender: TObject);
    procedure btn10Click(Sender: TObject);
    procedure btn11Click(Sender: TObject);
    procedure btn12Click(Sender: TObject);
    procedure tmr1Timer(Sender: TObject);
    procedure rb1Click(Sender: TObject);
    procedure rb2Click(Sender: TObject);
    procedure chk1Click(Sender: TObject);
    procedure trckbr2Change(Sender: TObject);
    procedure btn13Click(Sender: TObject);
    procedure btn14Click(Sender: TObject);
    procedure pnl1Resize(Sender: TObject);
    procedure chk2Click(Sender: TObject);
    procedure edt1Change(Sender: TObject);
    procedure chk3Click(Sender: TObject);
    procedure trckbr3Change(Sender: TObject);
    procedure btn15Click(Sender: TObject);
    procedure trckbr4Change(Sender: TObject);
    procedure pnl1Paint(Sender: TObject);
    procedure btn16Click(Sender: TObject);
    procedure trckbr5Change(Sender: TObject);
  private
    IsContex: Boolean;
    IsPerspectiv: Boolean;
    DC: HDC;
    RC: HGLRC;
    Camera: TglCamerAH;
    IsOpenGL: Boolean;
    procedure DefContext;
    procedure OpenGLDestroy;
    procedure Render;
    procedure Update;
    procedure Reset;
    procedure RenderObjects;
    procedure RenderSelect;
  public
  end;

var
  Form1: TForm1;

implementation

uses
  CamerAHBasis, dglOpenGL, CamerAHGeometry, figures;

{$R *.dfm}

procedure TForm1.btn10Click(Sender: TObject);
begin
  Camera.RotMode := rmArcBall;
end;

procedure TForm1.btn11Click(Sender: TObject);
begin
  Camera.Adjust(TView(Ord(rgView.ItemIndex)), chkInvers.Checked);
  Render;
end;

procedure TForm1.btn12Click(Sender: TObject);
begin
  Camera.RotMode := rmZoomPlus;
end;

procedure TForm1.btn13Click(Sender: TObject);
begin
  Reset;
  Render;
end;

procedure TForm1.btn14Click(Sender: TObject);
begin
  Camera.RotMode := rmZoomMinus;
  Render;
end;

procedure TForm1.btn15Click(Sender: TObject);
begin
  Camera.RotMode := rmNothing;
end;

procedure TForm1.btn16Click(Sender: TObject);
begin
  Camera.RotMode := rmSelect;
end;

procedure TForm1.btn1Click(Sender: TObject);
begin
  Camera.RotMode := rmFlexAxis;
end;

procedure TForm1.btn2Click(Sender: TObject);
begin
  Camera.RotMode := rmMove;
end;

procedure TForm1.btn3Click(Sender: TObject);
begin
  Camera.RotMode := rmDepthMove;
end;

procedure TForm1.btn4Click(Sender: TObject);
begin
  Camera.RotMode := rmRotX;
end;

procedure TForm1.btn5Click(Sender: TObject);
begin
  Camera.RotMode := rmRotY;
end;

procedure TForm1.btn6Click(Sender: TObject);
begin
  Camera.RotMode := rmRotZ;
end;

procedure TForm1.btn7Click(Sender: TObject);
begin
  Camera.RotMode := rmRotCoordX;
end;

procedure TForm1.btn8Click(Sender: TObject);
begin
  Camera.RotMode := rmRotCoordY;
end;

procedure TForm1.btn9Click(Sender: TObject);
begin
  Camera.RotMode := rmRotCoordZ;
end;

procedure TForm1.chk1Click(Sender: TObject);
begin
  Camera.IsMovePoR := chk1.Checked;
end;

procedure TForm1.chk2Click(Sender: TObject);
begin
  Camera.IsScreenAdjust := chk2.Checked;
  Render;
end;

procedure TForm1.chk3Click(Sender: TObject);
begin
  Camera.IsafterRotation := chk3.Checked;
end;

procedure TForm1.DefContext;
begin
  if not InitOpenGL then
    exit;
  IsOpenGL := True;

  DC := getDC(pnl1.Handle);
  RC := CreateRenderingContext(DC, [opDoubleBuffered],
    32,
    24,
    0, 0, 0,
    0);
  ActivateRenderingContext(DC, RC);
end;

procedure TForm1.edt1Change(Sender: TObject);
begin
  Camera.ArcBallRadius := StrToFloatDef(TEdit(Sender).Text, 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  IsOpenGL := False;
  DefContext;
  Camera := TglCamerAH.Create;
  Reset;

  IsPerspectiv := False;
  Camera.OGLControl := pnl1;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Camera.Free;
  OpenGLDestroy;
end;

procedure TForm1.Reset;
begin
  Camera.PositionCamera(
    VectorMake(0.5,0.5, -1),
    VectorMake(0.5, 0.5, 0.5),
    VectorMake(0,1,0),
    VectorMake(0.5, 0.5, 0.5));
  Camera.SetProjection(-1, 1,  -1, 1,  1.0, 5);
end;

procedure TForm1.OpenGLDestroy;
var
  test1: Integer;
  Test2: Boolean;
begin
  wglMakeCurrent(DC, RC);
  DeactivateRenderingContext;
  Test2 := wglDeleteContext(RC);
  test1 := ReleaseDC(pnl1.Handle, DC);
  IsContex := False;
end;

procedure TForm1.pnl1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if (Button = mbLeft) and (Camera.RotMode = rmSelect) then
  begin
    Camera.RotateStart(X, Y);
    RenderSelect;
  end
  else if Button = mbLeft then
  begin
    Camera.RotateStart(X, Y);
    Render;
  end;
end;

procedure TForm1.pnl1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if Camera.RotateMove(X, Y) then
    Render;
end;

procedure TForm1.pnl1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  Camera.RotateStop;
  if Camera.IsafterRotation and (Camera.RotMode = rmArcBall) then
    while Camera.afterRotation do
    begin
      //if GetAsyncKeyState(VK_LBUTTON) < 0 then
      //  Exit;
      Application.ProcessMessages;
      Render;
    end;
  Render;
end;

procedure TForm1.pnl1Paint(Sender: TObject);
begin
  lbl6.Caption := 'PanelWidth : ' +IntToStr(TPanel(Sender).Width)+
    ' PanelHeight : ' +IntToStr(TPanel(Sender).Height);
end;

procedure TForm1.pnl1Resize(Sender: TObject);
begin
  if not IsOpenGL then
    Exit;

  if Assigned(Camera) then
  begin
    glViewport(0,0, pnl1.Width, pnl1.Height);
    Camera.Resize;
    Render;
  end;
end;

procedure TForm1.rb1Click(Sender: TObject);
begin
  IsPerspectiv := True;
  Render;
end;

procedure TForm1.rb2Click(Sender: TObject);
begin
  IsPerspectiv := False;
  Render;
end;

procedure TForm1.RenderObjects;
var
  V: TVector;
begin
  glEnable(GL_POINT_SMOOTH);
  glBegin(GL_POINTS);
  with Camera do
  begin
    glPointSize(15);
    glColor3f(1, 1, 1);
    glVertex3f(0, 0, 0);
    glColor3f(0, 1, 0);
    glVertex3f(0, 1, 0);
    glColor3f(0, 0, 1);
    glVertex3f(1, 0, 0);
    glColor3f(1, 0, 0);
    glVertex3f(0, 0, 1);
    glPointSize(50);
    glColor3f(1, 1, 1);
    glVertex3f(PointofView[0], PointofView[1], PointofView[2]);
    glColor3f(0, 1, 0);
    glVertex3f(PointofRotation[0], PointofRotation[1], PointofRotation[2]);
    glColor3f(0, 0, 0);
    glVertex3f(PointofCamera[0], PointofCamera[1], PointofCamera[2]);
    glColor3f(0, 0, 0);
    glVertex3f(ArcBallStart[0], ArcBallStart[1], ArcBallStart[2]);
    glColor3f(0, 0, 0);
    glVertex3f(ArcBallEnd[0], ArcBallEnd[1], ArcBallEnd[2]);
  end;
  glEnd;
  glBegin(GL_LINES);
  with Camera do
  begin
    glColor3f(0, 0, 1);
    glColor3f(0, 1, 0);
    glVertex3f(PointofRotation[0], PointofRotation[1], PointofRotation[2]);
    V := VectorAdd(PointofRotation, RotAxis1);
    glVertex3f(V[0], V[1], V[2]);
    glColor3f(0, 1, 0);
    glVertex3f(PointofRotation[0], PointofRotation[1], PointofRotation[2]);
    V := VectorAdd(PointofRotation, RotAxis2);
    glVertex3f(V[0], V[1], V[2]);
  end;
  glEnd;

  glLoadName(1);
  glEnable(GL_BLEND);
  glBlendFunc(GL_ONE_MINUS_SRC_ALPHA, GL_SRC_ALPHA);
  glPushMatrix;
  glTranslatef(0.25, 0.25, 0.25);
  glColor4f(1.0, 0, 0, 0.7);
  Cube(0.5, 0.5, 0.5, false, voffset, toffset, tscale);
  glPopMatrix;
  glPushMatrix;
  with Camera do
  begin
    glColor4f(1, 0, 0, 0.7);
  end;
  glPopMatrix;

  glDisable(GL_BLEND);
  CoordPlane;
end;

procedure TForm1.RenderSelect;
var
  x: TSelectionResults;
begin
  Camera.Apply;

  RenderObjects;
  X := Camera.SelectionResult;
end;

procedure TForm1.Render;
begin
  glClearColor(0.3, 0.4, 0.8, 0.0); //Hintergrundfarbe: Hier ein leichtes Blau
  glEnable(GL_DEPTH_TEST);          //Tiefentest aktivieren
  glEnable(GL_CULL_FACE);         //Backface Culling aktivieren

  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  if IsPerspectiv then
    Camera.Projection(pjPerspectiv)
  else
    Camera.Projection(pjOrtho);

  Camera.Apply;
  RenderObjects;

  SwapBuffers(DC);
  Update;
end;

procedure TForm1.tmr1Timer(Sender: TObject);
begin
  Render;
end;

procedure TForm1.trckbr1Change(Sender: TObject);
begin
  Camera.SpeedRot := TTrackBar(Sender).Position;
end;

procedure TForm1.trckbr2Change(Sender: TObject);
begin
  Camera.SpeedMove := TTrackBar(Sender).Position;
end;

procedure TForm1.trckbr3Change(Sender: TObject);
begin
  Camera.afterRotationdamping := trckbr3.Position / 100;
end;

procedure TForm1.trckbr4Change(Sender: TObject);
begin
  Camera.FillLevel := trckbr4.Position /100;
end;

procedure TForm1.trckbr5Change(Sender: TObject);
begin
  Camera.afterRotationSensitivity := trckbr5.Position / 100;
end;

procedure TForm1.Update;
var
  c, r: Integer;
begin
  with strngrd1 do
  begin
    c := 0;
    r := 0;
    ColWidths[0] := 85;
    Cells[1,r] := 'X/l';
    Cells[2,r] := 'Y/r';
    Cells[3,r] := 'Z/b';
    Cells[4,r] := 'M/t';

    with Camera do
    begin
      Inc(r);
      Cells[0,r] := 'Point of View';
      Cells[1,r] := FloatToStr(PointofView[0]);
      Cells[2,r] := FloatToStr(PointofView[1]);
      Cells[3,r] := FloatToStr(PointofView[2]);
      Inc(r);
      Cells[0,r] := 'Point of Rotation';
      Cells[1,r] := FloatToStr(PointofRotation[0]);
      Cells[2,r] := FloatToStr(PointofRotation[1]);
      Cells[3,r] := FloatToStr(PointofRotation[2]);
      Inc(r);
      Cells[0,r] := 'Point of Camera';
      Cells[1,r] := FloatToStr(PointofCamera[0]);
      Cells[2,r] := FloatToStr(PointofCamera[1]);
      Cells[3,r] := FloatToStr(PointofCamera[2]);
      Inc(r);
      Cells[0,r] := 'Clip-Plane';
      Cells[1,r] := FloatToStr(ClipPlane.left);
      Cells[2,r] := FloatToStr(ClipPlane.right);
      Cells[3,r] := FloatToStr(ClipPlane.bottom);
      Cells[4,r] := FloatToStr(ClipPlane.top);
      Inc(r);
      Cells[0,r] := 'X-Axis';
      Cells[1,r] := FloatToStr(CameraMatrix[0][0]);
      Cells[2,r] := FloatToStr(CameraMatrix[0][1]);
      Cells[3,r] := FloatToStr(CameraMatrix[0][2]);
      Inc(r);
      Cells[0,r] := 'Y-Axis';
      Cells[1,r] := FloatToStr(CameraMatrix[1][0]);
      Cells[2,r] := FloatToStr(CameraMatrix[1][1]);
      Cells[3,r] := FloatToStr(CameraMatrix[1][2]);
      Inc(r);
      Cells[0,r] := 'Z-Axis';
      Cells[1,r] := FloatToStr(CameraMatrix[2][0]);
      Cells[2,r] := FloatToStr(CameraMatrix[2][1]);
      Cells[3,r] := FloatToStr(CameraMatrix[2][2]);
      RowCount := r +1;
    end;
  end;
end;

end.
